#include<Line3D.h>

inline float sqr(float x) {return (x * x);}

Line3D::Line3D()
{
  x1 = 0.0;
  y1 = 0.0;
  x2 = 0.0;
  y2 = 0.0;
  X1 = 0.0;
  Y1 = 0.0;
  Z1 = 0.0;
  X2 = 0.0;
  Y2 = 0.0;
  Z2 = 0.0;
  conf = 0.0;
  contrast = 0.0;
  dispersion = 0.0;
  region = 0;
  length = 0;
  theta = 0;
}

Line3D::Line3D(float X13D, float Y13D, float Z13D, 
	       float X23D, float Y23D, float Z23D,
	       float X12D, float Y12D, float X22D, float Y22D,
	       float confidence)
{
  x1 = X12D;
  y1 = Y12D;
  x2 = X22D;
  y2 = Y22D;
  X1 = X13D;
  Y1 = Y13D;
  Z1 = Z13D;
  X2 = X23D;
  Y2 = Y23D;
  Z2 = Z23D;

  conf = confidence;
  contrast = 0.0;
  dispersion = 0.0;
  region = 0;
  length = sqrt(sqr(X2-X1) + sqr(Y2 - Y1) + sqr(Z2 - Z1));
  theta = atan2((y2 - y1), (x2 - x1));
}

void Line3D::output (Isrostream& dest) 
{
  dest << "Line3D from (" << x1 << ", " << y1 << ") to (" 
    << x2 << ", " << y2 << ")\n";
  dest << "and from (" << X1 << ", " << Y1 << ", " << Z1 << ") to ("
    << X2 << ", " << Y2 << ", " << Z2 << ")\n";
  dest << "Theta = " << theta << ", Contrast = " << contrast;
  dest << ", Disp = " << dispersion << "\n"; 
  dest << "Length = " << length << ", Region = " << region << "\n";
  dest << "conf = " << conf << "\n";
  dest << "coord =" << GetCoordinates() << "\n";
}

void Line3D::input (Isristream& source)
{
  source >> "Line3D from (" >> x1 >> "," >> y1 >> ") to (" >> x2 >> "," 
    >> y2 >> ")";
  source >> "and from (" >> X1 >> "," >> Y1 >> "," >> Z1 >> ") to ("
    >> X2 >> "," >> Y2 >> "," >> Z2 >> ")";
  source >> "Theta = " >> theta >> ", Contrast = " >> contrast 
       >> ", Disp = " >> dispersion; 
  source >> "Length = " >> length >> ", Region = " >> region;
  source >> "conf =" >> conf >> "coord =";
  coord = (CoordSys2D*)read_token_ptr(source);
  double minx,miny,maxx,maxy;
  if (x1 < x2) {minx = x1;maxx = x2;}
  else	       {minx = x2;maxx = x1;}
  if (y1 < y2) {miny = y1;maxy = y2;}
  else	       {miny = y2;maxy = y1;}
  SetBoundingBox(minx,miny,maxx,maxy);
}

void Line3D::output_inventor(ofstream& os)
{
  os << "Separator {\n  Coordinate3 {\n    point [\n";
  os << "        " << X1 << " " << Y1 << " " << Z1 << ",\n";
  os << "        " << X2 << " " << Y2 << " " << Z2 << "\n";
  os << "      ]\n  }\n";
  os << "  IndexedLineSet {\n    coordIndex [ 0, 1, -1]\n  }\n}";
}




