#include <Point3D.h>

/* Point3D.cc
   Created 10/23/95 by James Doyle
   This module provides the Point3D class, which essentially consists
of x,y,and z coordinates in 3D space.
*/

Point3D::Point3D() : x(0), y(0), z(0), i(0), j(0) {}

Point3D::Point3D(double newx, double newy, double newz, int newi, int newj) 
: x(newx), y(newy), z(newz), i(newi), j(newj) {}

void Point3D::output(Isrostream& os)
{
  os << "Point3D at (" << x << "," << y << "," << z << ","
     << i << "," << j << ")\n";
}

void Point3D::input(Isristream& is)
{
  is >> "Point3D at (" >> x >> "," >> y >> "," >> z >> ","
     >> i >> "," >> j >> ")";
}

bool Point3D::operator==(Point3D& that)
{
  return ((x==that.x) && (y==that.y) && (z==that.z));
}

Point3D::operator Vector3D()
{
  return Vector3D(x,y,z);
}
