#ifndef POINT3D_DEFINED
#define POINT3D_DEFINED
#include <Token.h>
#include <Vector3D.h>

/* Point3D.h
   Created 10/23/95 by James Doyle
   This module provides the Point3D class, which essentially consists
of x,y,and z coordinates in 3D space.  Points can be constructed
directly from these coordinates.  An equality operator, as well as
input and output, are provided.  There is also a conversion to a
Vector3D, which returns the Vector3D whose components are equal to the
coordinates of the point.
*/

class Point3D : public Token {
  
 public:
  double x, y, z;		// 3D coordinates
  int i, j;			// 2D grid coordinates
  
  Point3D();
  Point3D(double newx, double newy, double newz, int newi=-1, int newj=-1);
  char *name() const { return "Point3D"; }
  bool operator==(Point3D& that);

  void output(Isrostream& os);
  void input(Isristream& is);

  operator Vector3D();
};

#endif
